# `spm`

Salt Package Manager

## Synopsis

    spm <command> [<argument>]

## Description

spm is the frontend command for managing Salt packages. Packages normally only include formulas, meaning a group of SLS files that install into the `file_roots` on the Salt Master, but Salt modules can also be installed.

## Options

-y, --assume-yes

  Assume `yes` instead of prompting the other whether or not to proceed with a particular command. Default is False.

-f, --force

  When presented with a course of action that spm would normally refuse to perform, that action will be performed anyway. This is often destructive, and should be used with caution.

### Logging Options

Logging options which override any settings defined on the configuration files.

-l LOG_LEVEL, --log-level=LOG_LEVEL

  Console logging log level. One of `all`, `garbage`, `trace`, `debug`, `info`, `warning`, `error`, `quiet`. Default: `warning`.

--log-file=LOG_FILE

  Log file path. Default: /var/log/salt/spm.

--log-file-level=LOG_LEVEL_LOGFILE

  Logfile logging log level. One of `all`, `garbage`, `trace`, `debug`, `info`, `warning`, `error`, `quiet`. Default: `warning`.

## Commands

update_repo

  Connect to remote repositories locally configured on the system and download their metadata.

install

  Install a package from a configured SPM repository. Requires a package name.

remove

  Remove an installed package from the system. Requires a package name.

info

  List information about an installed package. Requires a package name.

files

  List files belonging to an installed package. Requires a package name.

local

  Perform one of the above options (except for remove) on a package file, instead of on a package in a repository, or an installed package. Requires a valid path to a local file on the system.

build

  Build a package from a directory containing a FORMULA file. Requires a valid path to a local directory on the system.

create_repo

  Scan a directory for valid SPM package files and build an SPM-METADATA file in that directory which describes them.

## See also

salt(1) salt-master(1) salt-minion(1)